package hexagon.renderer

import org.lwjgl.opengl.GL30
import scala.collection.mutable.ArrayBuffer

class VAO(vaoID: Int, val maxCount: Int, val maxPrimCount: Int, val vbos: Seq[VBO]) {
  def bind() = GL30.glBindVertexArray(vaoID)
}

class VAOBuilder(maxCount: Int, maxPrimCount: Int = 1) {
  private val vbos = ArrayBuffer.empty[VBO]
  val vaoID = GL30.glGenVertexArrays()
  GL30.glBindVertexArray(vaoID)
  
  def addVBO(vbo: VBO): VAOBuilder = {
    vbos += vbo
    this
  }
  
  def create() = new VAO(vaoID, maxCount, maxPrimCount, vbos)
}