package hexagon.world.render

import hexagon.world.storage.World
import hexagon.Camera
import hexagon.resource.Shader

class WorldRenderer(world: World) {
  val blockShader = Shader.getShader("block")
  
  def render(camera: Camera): Unit = {
    blockShader.enable()
    
    world.columns.values.foreach(_.chunks.values.foreach(c => {
      if (c.renderer != null) c.renderer.render()
    }))
  }
}