package hexagon.world.storage

import hexagon.world.coord.ColumnRelWorld
import hexagon.world.coord.BlockRelWorld

class World {
  /* blockStorage
   * other world contents
   * methods for world interaction
   * method for loading/unloading blockColumns
   * block methods that will be forwarded to the correct chunk
   * worldGen references and methods
   * might rename this class to WorldStorage, and make another class World
  */
  
  val ringSize = 16
  val totalSize = 16 * ringSize
  
  val columns = scala.collection.mutable.Map.empty[Long, ChunkColumn]
  for (i <- -8 until 8; j <- -8 until 8) columns += ColumnRelWorld(i, j, this).value -> new ChunkColumn(ColumnRelWorld(i, j, this), this)// TODO: temp
  
  def getColumn(coords: ColumnRelWorld) = columns.get(coords.value)
  
  def getBlock(coords: BlockRelWorld): Option[Block] = getColumn(coords.getColumnRelWorld) match {
    case Some(col) => col.getBlock(coords.getBlockRelColumn)
    case None => None
  }
  
  def tick(): Unit = {
    columns.values.foreach(_.tick)
  }
  
}