package hexagon.world.storage

import hexagon.world.coord.ColumnRelWorld
import hexagon.world.coord.ChunkRelColumn
import hexagon.world.coord.BlockRelColumn

class ChunkColumn(val coords: ColumnRelWorld, val world: World) {
  /* chunks
   * method for loading/unloading top and bottom chunk
  */
  
  val chunks = scala.collection.mutable.Map.empty[Int, Chunk]
  chunks += ((-1) & 0xfff) -> new Chunk(ChunkRelColumn((-1) & 0xfff).withColumn(coords), world)
  
  def getChunk(coords: ChunkRelColumn) = chunks.get(coords.value)
  
  def getBlock(coords: BlockRelColumn): Option[Block] = getChunk(coords.getChunkRelColumn) match {
    case Some(chunk) => chunk.getBlock(coords.getBlockRelChunk)
    case None => None
  }
  
  def tick(): Unit = {
    chunks.values.foreach(_.tick)
  }
  
}