package hexagon.world.storage

import hexagon.world.coord.BlockRelWorld
import org.joml.Vector3f
import hexagon.world.coord.CylCoord

object Block {
  val neighborOffsets = Seq(
      ( 0, 1, 0),
			( 0,-1, 0),
			( 1, 0, 0),
			( 0, 0, 1),
			(-1, 0, 1),
			(-1, 0, 0),
			( 0, 0,-1),
			( 1, 0,-1))
	
	val vertices = {
    val ints = Seq(1, 2, 0, 3, 5, 4)
    
    (0 to 1).map(s =>
      (0 until 6).map(i => {
    		val v = i * Math.PI / 3
  			val x = Math.cos(v).toFloat
    		val z = Math.sin(v).toFloat
  			new CylCoord(x * 0.5, (1 - s) * 0.5, z * 0.5, false)
      })
    ).flatten
  }
  
	def getVertices(side: Int): Seq[CylCoord] = {
    side match {
      case 0 => vertices.take(6)
      case 1 => vertices.takeRight(6).reverse
      case s => Seq(vertices(s-2), vertices(s-2+6), vertices((s-1+6) % 6 + 6), vertices((s-1+6) % 6))
    }
  }
}

class Block(val coord: BlockRelWorld, val blockType: Byte) {
  
}