
out vec4 color;

uniform vec2 windowSize;
uniform mat4 invProjMatr;
uniform mat4 invViewMatr;
uniform vec3 sun;

void main() {
	vec4 coordsBeforeMatr = vec4(gl_FragCoord.x / windowSize.x * 2 - 1, gl_FragCoord.y / windowSize.y * 2 - 1, -1, 1);
	vec4 coordsAfterProj = invProjMatr * coordsBeforeMatr;
	vec3 ray = normalize((invViewMatr * vec4(coordsAfterProj.xy, -1, 0)).xyz);
	vec3 theSun = normalize(sun);
	float sunBrightness = max(dot(ray, theSun) * 5000 - 4999, 0);
	
	color = vec4(sunBrightness * vec2(0.9, 0.8) + vec2(0.1, 0.2), 0.7, 1);
}