package hexagon.resource

import scala.collection.mutable.Set

object Resource {
  private val resources = Set.empty[Resource]

  def freeAllResources(): Unit = {
    resources.clone().foreach(_.free)
  }
  
  def reloadAllResources(): Unit = {
    resources.foreach(_.reload)
  }
}

abstract class Resource {
  Resource.resources += this

  final def free(): Unit = {
    unload()
    Resource.resources -= this
  }
  
  protected def reload(): Unit
  protected def unload(): Unit
}
