package hexagon.world.blockType

import javax.imageio.ImageIO
import java.io.File
import hexagon.resource.Resource

object BlockTexture {
  val blockTextureSize: Int = 32
}

class BlockTexture(path: String) extends Resource {
  private var _images: Seq[Array[Int]] = _
  def images = _images
  
  load

  def load(): Unit = {
    val file = new File(path)
    _images = if (file.isFile()) {
      val image = ImageIO.read(file)
      val w = image.getWidth
      val h = image.getHeight
      for (i <- List.range(0, w / h)) yield image.getRGB(i * h, 0, h, h, null, 0, h)
    } else Seq.empty
  }
  
  def reload(): Unit = load// TODO: this does not work. Make the new resource-loading-system instead of fixing this here
  
  def unload(): Unit = ()
}
