package hexagon.world.blockType

import hexagon.HexBox
import hexagon.world.coord.CoordUtils

object BlockType {
  private val maxBlocks = 256
  
  private val blocks = new Array[BlockType](maxBlocks)
  def byId(id: Byte): BlockType = blocks(id)
  
  val Air       = BlockTypeAir
  val Stone     = new BlockType(1, "stone", "Stone")
  val Grass     = new BlockType(2, "grass", "Grass")
  val Dirt      = new BlockType(3, "dirt", "Dirt")
  val Sand      = new BlockType(4, "sand", "Sand")

  def init(): Unit = {
  }
}

class BlockType(val id: Byte, val name: String, val displayName: String) {
  BlockType.blocks(id) = this
  
  protected val texture = new BlockTexture(name)
  val bounds = new HexBox(0.5f, 0, 0.5f)
  
  def blockTex(side: Int): Int = texture.indices(side)
  def canBeRendered: Boolean = true
}

object BlockTypeAir extends BlockType(0, "air", "Air") {
  override def canBeRendered: Boolean = false
}
